routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    if (Auth::check())
        return redirect()->route('home');
    else
        return redirect()->route('login');
});

// Register login, register, password-reset, and other lovely core stuff.
Auth::routes();

Route::get('register/thanks', 'Auth\RegisterController@thanks')->name('register.thanks');
Route::get('register/to/{city_slug}/{section_id}', 'Auth\RegisterController@sectionPreload')->name('register.tosection');

Route::middleware(['auth'])->group(function () {
    Route::get('home', 'HomeController@index')->name('home');

    Route::post('user/approve', 'UserController@approve')->name('user.approve');
    Route::get('user/bypass/{id}', 'UserController@bypass')->name('user.bypass');

    Route::get('movement/review', 'MovementController@review')->name('movement.review');
    Route::post('movement/attach/{id}', 'MovementController@attach')->name('movement.attach');
    Route::post('movement/refund/{id}', 'MovementController@refund')->name('movement.refund');
    Route::get('movement/download', 'MovementController@download')->name('movement.download');

    Route::get('section/{id}/balance', 'SectionController@balance')->name('section.balance');
    Route::post('section/{id}/exportmembers', 'SectionController@exportmembers')->name('section.exportmembers');

    Route::get('refund/download', 'RefundController@download')->name('refund.download');

    Route::get('sponsor/logo/{id}', 'SponsorController@logo')->name('sponsor.logo');

    Route::get('doc/download', 'DocumentationController@download')->name('doc.download');
    Route::get('doc/link', 'DocumentationController@link')->name('doc.link');
    Route::get('doc/preview', 'DocumentationController@preview')->name('doc.preview');

    Route::post('assembly/partecipate/{assembly_id}/{do}', 'AssemblyController@partecipate')->name('assembly.partecipate');
    Route::post('assembly/delegate/{assembly_id}/{delegate_id}', 'AssemblyController@delegate')->name('assembly.delegate');

    Route::get('bank/list/', 'BankController@list')->name('bank.list_all');
    Route::get('bank/list/{id}', 'BankController@list')->name('bank.list');

    Route::resource('user', 'UserController');
    Route::resource('volunteer', 'VolunteerController');
    Route::resource('doc', 'DocumentationController');
    Route::resource('config', 'ConfigController');
    Route::resource('bank', 'BankController');
    Route::resource('movement', 'MovementController');
    Route::resource('rule', 'RuleController');
    Route::resource('section', 'SectionController');
    Route::resource('receipt', 'ReceiptController');
    Route::resource('refund', 'RefundController');
    Route::resource('assembly', 'AssemblyController');
    Route::resource('votation', 'VotationController');
    Route::resource('vote', 'VoteController');
    Route::resource('sponsor', 'SponsorController');
});

app/Bank.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Bank extends Model
{
    public function movements()
    {
        return $this->hasMany('App\Movement');
    }

    public function rules()
    {
        return $this->hasMany('App\AccountRule');
    }

    public static function types()
    {
        return [
            (object) [
                'identifier' => 'paypal',
                'label' => 'PayPal'
            ],
            (object) [
                'identifier' => 'unicredit',
                'label' => 'Unicredit Banca'
            ],
        ];
    }

    public function getLastUpdateAttribute()
    {
        /*
            In fase di importazione degli estratti conto PayPal creo un
            movimento per tenere traccia delle commissioni, che però non deve
            essere considerato come ultimo movimento
        */
        if ($this->type == 'paypal') {
            return $this->movements()->where('notes', '!=', 'Commissioni PayPal')->max('date');
        }
        else {
            return $this->movements()->max('date');
        }
    }
}

app/Movement.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Collection;

use DB;

use App\AccountRow;
use App\Config;

/**
 * A Movement is a money transfer from (or to) your bank account(s).
 * A Movement may create AccountRow(s).
 * Each Movement may generate a single Receipt.
 */
class Movement extends Model
{

    private $accountRowsInSum;
    private $accountRowsOutSum;

    public function bank()
    {
        return $this->belongsTo('App\Bank');
    }

    public function account_rows()
    {
        return $this->hasMany('App\AccountRow')->with('user');
    }

    public function receipt()
    {
        return $this->hasOne('App\Receipt');
    }

    public function refund()
    {
        return $this->hasMany('App\Refund');
    }

    public function getAttachmentsPathAttribute()
    {
        return storage_path('accounting/' . $this->id);
    }

    public function getAttachmentsAttribute()
    {
        $ret = new Collection();

        $path = $this->attachments_path;
        if (file_exists($path)) {
            $files = scandir($path);

            foreach($files as $f) {
                if ($f[0] === '.')
                    continue;

                $ret->push($f);
            }
        }

        return $ret;
    }

    /**
     * Get the year of this Movement's date.
     *
     * @return int Year of the date
     */
    public function getDateYearAttribute()
    {
        if( !$this->date ) {
            throw new \Exception("No date, no party");
        }
        return (int) substr($this->date, 0, 4);
    }

    /**
     * Get the already-imported Movement.
     *
     * @return Movement|null
     */
    public function alreadyTrackedMovement()
    {
        $query = Movement::query();

        // Skip myself if I'm already persisted.
        if (!empty($this->id))
        {
            $query = $query->where('id', '<>', $this->id);
        }

        // Base condition. Look for the copy of myself under the same bank.
        $query = $query->where('bank_id', $this->bank_id);

        // If the bank+identifier is available, use just these robust info.
        if (!empty($this->identifier))
        {
              $query = $query->where('identifier', $this->identifier);
        }
        else
        {
            // No identifier. Do desperate things.
            // Pitfall: Unicredit randomly changes "notes"...
            $query = $query->where('date', $this->date)
                           ->where('amount', $this->amount)
                           ->where('notes', $this->notes);
        }

        return $query->first();
    }

    /**
     * Check if this (non-persisted) Movement was already imported.
     * @return bool
     */
    public function alreadyTracked()
    {
        return !is_null( $this->alreadyTrackedMovement() );
    }

    public function attachFile($file)
    {
        $file->move($this->attachments_path, $file->getClientOriginalName());
    }

    public function getFeePayments($user)
    {
        $ret = new Collection();

        if (!is_object($user)) {
            $user_id = $user;
            $user = User::find($user_id);
            if (is_null($user)) {
                Log::error('Errore nel riconoscimento utente di cui generare le quote di iscrizione: ' . $user_id);
                return $ret;
            }
        }

        $fees_account = Config::feesAccount();
        $donations_account = Account::where('donations', true)->first();

        $amount = $this->amount;
        $year = $user->firstMissingFeeYear();
        $guessed = true;

        while($amount >= $user->feeAmount()) {
            $ar = new AccountRow();
            $ar->movement_id = $this->id;
            $ar->account_id = $fees_account->id;
            $ar->amount_in = $user->feeAmount();
            $ar->user_id = $user->id;
            $ar->notes = AccountRow::createFeeNote($user, $year);
            $ret->push($ar);

            $amount -= $user->feeAmount();
            $year++;
        }

        if ($amount != 0) {
            $ar = new AccountRow();
            $ar->movement_id = $this->id;
            $ar->account_id = $donations_account->id;
            $ar->amount_in = $amount;
            $ar->notes = sprintf('Donazione da parte di %s', $user->printable_name);
            $ret->push($ar);
        }

        return $ret;
    }

    /**
     * Find the most recent Account Row from the whole history, using a generic note
     *
     * @param string $guess_by_note
     * @return AccountRow
     */
    public function getAccountRowFromHistory($guess_by_note)
    {
        $prev_movement = Movement::where('notes', 'like', $guess_by_note)->has('account_rows')->orderBy('id', 'desc')->first();

        if ($prev_movement) {
            $prev_account_row = $prev_movement->account_rows()->first();
            if ($prev_account_row) {
                $ar = new AccountRow();
                $ar->movement_id = $this->id;
                $ar->account_id = $prev_account_row->account_id;
                $ar->user_id = $prev_account_row->user_id;
                $ar->section_id = $prev_account_row->section_id;
                $ar->notes = $prev_account_row->notes;

                if ($this->amount > 0)
                    $ar->amount_in = abs($this->amount);
                else
                    $ar->amount_out = abs($this->amount);

                return $ar;
            }
        }

        return null;
    }

    private function guessByRules()
    {
        foreach($this->bank->rules as $rule) {
            if (preg_match($rule->fixed_rule, $this->notes)) {
                $ar = new AccountRow();
                $ar->movement_id = $this->id;
                $ar->account_id = $rule->account_id;
                $ar->notes = $rule->notes;

                if ($this->amount > 0)
                    $ar->amount_in = abs($this->amount);
                else
                    $ar->amount_out = abs($this->amount);

                $ret = new Collection();
                $ret->push($ar);
                return $ret;
            }
        }

        return null;
    }

    public function guessRows()
    {
        $ret = $this->guessByRules();
        $guessed = false;

        if ($ret) {
            $guessed = true;
        }
        else {
            $ret = new Collection();

            if ($this->bank->type === 'paypal') {
                list($name, $email, $causal) = explode(' - ', $this->notes . " -  -  - ", 3);

                // try to find from the users table using name and surname
                // @TODO: if an user on PayPal has 1 name, and on ILS Manager has 2+ names, it won't be found

                // TODO: evaluate for removal
                $name = str_replace("'", "\'", $name);

                $user = User::where(DB::raw("CONCAT(name, ' ', surname)"), $name)->first();
                if (!is_null($user) && $this->amount >= $user->feeAmount()) {
                    $ret = $this->getFeePayments($user);
                    $guessed = true;
                }
                else {
                    // try to find from the already-imported Account Rows

                    $guess_note = sprintf('%s - %s - %%', $name, $email);
                    $ar = $this->getAccountRowFromHistory($guess_note);
                    if ($ar) {

                        // check if this a "Saldo quota YYYY"
                        $year = $ar->getFeeYear();

                        if( $year && is_numeric($year) ) {
                            // propose a copy of this AccountRow with year + 1
                            $ar_proposed = $ar->replicate();
                            $ar_proposed->notes = AccountRow::createFeeNote( $ar->user, $year + 1 );

                            $ret->push($ar_proposed);
                        } else {

                            // just propose this AccountRow as-is
                            $ret->push($ar);
                        }

                        $guessed = true;
                    }
                }
            }
            else if ($this->bank->type === 'unicredit') {
                $name = trim(preg_replace('/^BONIFICO A VOSTRO FAVORE BONIFICO SEPA DA ([A-Z ]*) PER .*$/', '\1', $this->notes));
                $user = User::where(DB::raw("CONCAT(surname, ' ', name)"), $name)->first();
                if (!is_null($user) && $this->amount >= $user->feeAmount()) {
                    $ret = $this->getFeePayments($user);
                    $guessed = true;
                }
                else {
                    $ar = $this->getAccountRowFromHistory($this->notes);
                    if ($ar) {
                        $ret->push($ar);
                        $guessed = true;
                    }
                }
            }
        }

        if ($guessed == false) {
            $ar = new AccountRow();

            if ($this->amount > 0)
                $ar->amount_in = abs($this->amount);
            else
                $ar->amount_out = abs($this->amount);

            $ret->push($ar);
        }

        return $ret;
    }

    /**
     * Get the AccountRows "IN" sum.
     * This is safe to be called multiple times.
     * @return float
     */
    public function getAccountRowsInSum()
    {
        if( !isset( $this->accountRowsInSum ) )
        {
            $this->accountRowsInSum = 0.0;
            foreach( $this->account_rows as $ar )
            {
                $this->accountRowsInSum += $ar->amount_in;
            }
        }
        return $this->accountRowsInSum;
    }

    /**
     * Get the AccountRows "IN" sum.
     * This is safe to be called multiple times.
     * @return float
     */
    public function getAccountRowsOutSum()
    {
        if( !isset( $this->accountRowsOutSum ) )
        {
            $this->accountRowsOutSum = 0.0;
            foreach( $this->account_rows as $ar )
            {
                $this->accountRowsOutSum += $ar->amount_out;

app/Refund.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Collection;

class Refund extends Model
{
    public function user()
    {
        return $this->belongsTo('App\User');
    }

    public function section()
    {
        return $this->belongsTo('App\Section');
    }

    public function movement()
    {
        return $this->belongsTo('App\Movement');
    }

    public function getPrintableDescriptionAttribute()
    {
        return sprintf('%s € - %s - %s', $this->amount, $this->user ? $this->user->printable_name : '?', $this->section ? 'Sezione Locale di ' . $this->section->city : 'Nessuna Sezione Locale');
    }

    public function getAttachmentsPathAttribute()
    {
        return storage_path('refunds/' . $this->id);
    }

    public function getAttachmentsAttribute()
    {
        $ret = new Collection();

        $path = $this->attachments_path;
        if (file_exists($path)) {
            $files = scandir($path);

            foreach($files as $f) {
                if ($f[0] == '.')
                    continue;

                $ret->push($f);
            }
        }

        return $ret;
    }

    public function attachFile($file)
    {
        $file->move($this->attachments_path, $file->getClientOriginalName());
    }

    /**
     * Get the RefundStatus object from this Refund.
     * @return RefundStatus
     */
    public function getRefundStatus()
    {
        return RefundStatus::findByID($this->refunded);
    }

}

resources/views/movement/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <p>
                Movimento {{ $movement->identifier ?? '' }} su banca {{ $movement->bank->name }}
            </p>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12">
            <form method="POST" action="{{ route('movement.update', 0) }}">
                @method('PUT')
                @csrf

                @include('movement.editblock', ['movement' => $movement])

                <br>

                <div class="form-group row">
                    <div class="col-sm-10">
                        <button type="submit" class="btn btn-primary">Salva</button>
                    </div>
                </div>
            </form>

            <div class="card mt-3">
                <div class="card-header">Allegati</div>

                <div class="card-body">
                    <ul>
                        @foreach($movement->attachments as $attach)
                            <li><a href="{{ route('movement.download', ['file' => $movement->id . '/' . $attach]) }}">{{ basename($attach) }}</a></li>
                        @endforeach
                    </ul>

                    <form method="POST" action="{{ route('movement.attach', $movement->id) }}" enctype="multipart/form-data">
                        @csrf

                        <div class="form-group row">
                            <div class="col-sm-4">
                                <input type="file" class="form-control" name="file">
                            </div>
                            <div class="col-sm-2">
                                <button type="submit" class="btn btn-primary">Allega File</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>

            @if($movement->amount > 0)
                <div class="card mt-3">
                    <div class="card-header">Ricevuta</div>

                    <div class="card-body">
                        @if($movement->receipt)
                            <a class="btn btn-default" href="{{ $movement->receipt->link }}">Scarica Ricevuta {{ $movement->receipt->full_number }}</a>
                        @else
                            <form method="POST" action="{{ route('receipt.store') }}">
                                @csrf

                                <input type="hidden" name="movement_id" value="{{ $movement->id }}">

                                <div class="form-group row">
                                    <label for="date" class="col-sm-4 col-form-label">Data</label>
                                    <div class="col-sm-8">
                                        <input type="text" class="form-control" name="date" value="{{ date('Y-m-d') }}">
                                    </div>
                                </div>

                                <div class="form-group row">
                                    <label for="header" class="col-sm-4 col-form-label">Intestazione</label>
                                    <div class="col-sm-8">
                                        <textarea class="form-control" name="header"></textarea>
                                    </div>
                                </div>

                                <div class="form-group row">
                                    <label for="causal" class="col-sm-4 col-form-label">Causale</label>
                                    <div class="col-sm-8">
                                        <textarea class="form-control" name="causal"></textarea>
                                    </div>
                                </div>

                                @if($movement->amount >= 77.47)
                                    <div class="form-group row">
                                        <label for="stamp" class="col-sm-4 col-form-label">Marca da Bollo</label>
                                        <div class="col-sm-8">
                                            <input type="text" class="form-control" name="stamp">
                                        </div>
                                    </div>
                                @endif

                                <hr>
                                <div class="form-group row">
                                    <div class="col-sm-10">
                                        <button type="submit" class="btn btn-primary">Genera Ricevuta</button>
                                    </div>
                                </div>
                            </form>
                        @endif
                    </div>
                </div>
            @else
                <div class="card mt-3">
                    <div class="card-header">Rimborsi Spese</div>

                    <div class="card-body">
                        @if($movement->refund->isEmpty() == false)
                            <ul>
                                @foreach($movement->refund as $r)
                                    <li><a href="{{ route('refund.edit', $r->id) }}">{{ $r->printable_description }}</a></li>
                                @endforeach
                            </ul>
                        @else
                            <?php $pendings = App\Refund::where('refunded', false)->whereDoesntHave('movement')->get() ?>

                            @if($pendings->isEmpty())
                                <div class="alert alert-info">
                                    Non ci sono rimborsi spese in attesa.
                                </div>
                            @else
                                <form method="POST" action="{{ route('movement.refund', $movement->id) }}">
                                    @csrf

                                    <fieldset class="form-group">
                                        <div class="row">
                                            <legend class="col-form-label col-sm-4 pt-0">Rimborsi in Attesa</legend>
                                            <div class="col-sm-8">
                                                @foreach($pendings as $p)
                                                    <div class="form-check">
                                                        <input class="form-check-input" type="checkbox" name="refund_id[]" value="{{ $p->id }}">
                                                        <label class="form-check-label">
                                                            {{ $p->printable_description }}
                                                        </label>
                                                    </div>
                                                @endforeach
                                            </div>
                                        </div>
                                    </fieldset>

                                    <div class="form-group row">
                                        <div class="col-sm-10">
                                            <button type="submit" class="btn btn-primary">Rimborsa</button>
                                        </div>
                                    </div>
                                </form>
                            @endif
                        @endif
                    </div>
                </div>
            @endif
        </div>
    </div>
</div>
@endsection

resources/views/movement/editblock.blade.php
<ul class="list-group">
    <li class="list-group-item">
        <div class="row">
            <div class="col-md-3">
                {{ $movement->date }}<br />
                <small>{{ $movement->bank->type }}</small>
            </div>
            <div class="col-md-3">
                {{ $movement->amount }}
            </div>
            <div class="col-md-6">
                {{ $movement->notes }}

                <!-- Remove Movement: start -->
                @if( empty($movement->identifier) )
                <div class="form-check float-right">
                    <input class="form-check-input" type="checkbox" name="remove[]" value="{{ $movement->id }}" id="remove{{ $movement->id }}">
                    <label class="form-check-label" for="remove{{ $movement->id }}">
                        Elimina
                    </label>
                </div>
                @endif
                <!-- Remove Movement: stop -->
            </div>
        </div>
    </li>

    <!-- Account Rows Sum warning: start -->
    @if( !$movement->account_rows->isEmpty() && !$movement->isAmountMatchingAccountRows() )
    <li class="list-group-item">
        <div class="alert alert-danger account-rows-sum-danger" role="alert">
          <p><b>Errore Sommatoria</b></p>
          <p>Correggere gli importi delle sottostanti righe contabili, affinché il loro totale corrisponda a quello del movimento bancario.<br />
             Scarto rilevato:
             <b class="account-rows-amount-diff-error">{{ sprintf('%.02f', $movement->getAccountRowsAmountDiffError() ) }}</b> EUR
          </p>
        </div>
    </li>
    @endif
    <!-- Account Rows Sum warning: end -->

    @if(!$movement->account_rows->isEmpty())
        @foreach($movement->account_rows as $ar)
            @include('accountrow.editblock', ['ar' => $ar])
        @endforeach
    @elseif(($guessed = $movement->guessRows())->isEmpty() == false)
        @foreach($guessed as $ar)
            @include('accountrow.editblock', ['ar' => $ar])
        @endforeach
    @else
        @include('accountrow.editblock', ['ar' => null])
    @endif

    <li class="list-group-item">
        <button class="btn btn-default btn-sm add-row"><span class="oi oi-plus"></span></button>
        <ul class="hidden">
            @include('accountrow.editblock', ['ar' => null])
        </ul>
    </li>
</ul>

resources/views/movement/review.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <p>
                Correggere manualmente i movimenti legati a fatture dei fornitori, nella causale specifica il numero di fattura e magari la motivazione.
            </p>
        </div>
    </div>

    @if($pendings->isEmpty() == false)
        <div class="row">
            <div class="col-md-12">
                <form method="POST" action="{{ route('movement.update', 0) }}">
                    @method('PUT')
                    @csrf

                    @foreach($pendings as $movement)
                        @include('movement.editblock', ['movement' => $movement])
                        <br>
                    @endforeach

                    <div class="form-group row">
                        <div class="col-sm-10">
                            <button type="submit" class="btn btn-primary">Salva</button>
                        </div>
                    </div>
                </form>

                {!! $pendings->links() !!}
            </div>
        </div>
    @endif
</div>
@endsection